<template>
    <div>

        <div class="row inbox-wrapper">
            <div class="col-md-12 col-xl-12 middle-wrapper">
                <div class="row">
                    <div class="col-md-12 grid-margin">
                        <div class="card rounded">
                            <div class="card-header">
                                <div class="d-flex align-items-center justify-content-between">
                                    <div class="d-flex align-items-center">                
                                        <div class="ml-2">
                                            <p>Manajemen User</p>
                                            <p class="tx-11 text-muted">List user aktif</p>
                                        </div>
                                    </div>
                                    <div class="dropdown">
                                        <!-- <button type="button" class="btn btn-success btn-icon" @click="add()">
                                            <b-icon icon="plus-circle-fill"></b-icon>
                                        </button> -->
                                    </div>
                                </div>
                            </div>
                            <div class="card-body">
                                <div class="row align-items-center">
                                  <div class="col-md-6 grid-margin">
                                    <div class="form-inline">
                                      <label class="mr-2">Pencarian</label>
                                      <input
                                      type="text"
                                      placeholder="Ketikan pencarian disini"
                                      class="form-control"
                                      v-model="filter"
                                      />
                                  </div>
                              </div>
                              <div class="col-md-6 grid-margin">
                                <div class="form-inline float-right">
                                  <label class="mr-2">Lihat</label>
                                  <select class="form-control" v-model="per_page">
                                    <option value="10">10</option>
                                    <option value="25">25</option>
                                    <option value="50">50</option>
                                    <option value="100">100</option>
                                </select>
                                <label class="ml-2">Entri</label>
                            </div>
                        </div>
                    </div>
                    <div class="row">                          
                        <div class="table-responsive col-md-12">
                            <b-table
                            id="data-table"
                            responsive
                            hover
                            :filter="filter"
                            :items="dataList"
                            :fields="fields"
                            :per-page="per_page"
                            :current-page="current_page"
                            :sort-by="sortBy"
                            :sort-desc="sortDesc"
                            @filtered="onFiltered"
                            show-empty
                            :busy="isBusy"
                            >
                            <template v-slot:table-busy>
                                <div class="text-center text-danger my-2">
                                  <b-spinner class="align-middle"></b-spinner>
                                  <strong>Loading...</strong>
                              </div>
                          </template>
                          <template v-slot:cell(index)="row">
                             {{(row.index+1)+(per_page*(current_page-1))}}   
                         </template>
                         <template v-slot:cell(confirmed)="row">
                             <span class="badge badge-success" v-if="row.item.confirmed == 1">{{ row.item.confirmed }}</span>
                             <span class="badge badge-danger" v-else>{{ row.item.confirmed }}</span>
                         </template>
                         <template v-slot:cell(roles)="row">
                             {{ getRole(row.item.roles) }}
                         </template>
                         <template v-slot:cell(actions)="row">
                             <button type="button" class="btn btn-primary btn-icon" @click="edit(row.item)">
                                <b-icon icon="pencil-fill"></b-icon>
                            </button>
                        </template>
                    </b-table>
                </div>   
                <div class="col-md-12">
                    <b-pagination
                    v-model="current_page"
                    :total-rows="total_rows"
                    :per-page="per_page"
                    align="right"
                    aria-controls="data-table"
                    ></b-pagination>
                </div>
            </div>
        </div>
    </div>
</div>
</div>
</div>
</div>

</div>
</template>

<script>

    export default {
        components: {  },
        props:['datakrs'],
        data() {
         return {
            url:'/admin/inovator',
            name:'table',
            emptyResult: false,
            dataList: [],
            totalSKS:0,
            current_page: 1,
            per_page: 10,
            filter: null,
            sortDesc: false,
            sortBy: "index",
            fields: [
            { key: "index", sortable: false, label: "#" },
            { key: "first_name", sortable: false, label: "Nama" },
            { key: "email", sortable: false, label: "Email" },
            { key: "confirmed", sortable: false, label: "Confirm" },
            { key: "roles", sortable: false, label: "Roles" },
            { key: "actions", label: "Action" },
            ],
            total_rows: 0,
            dataBentrok : {},
            isBusy:true,
            json_fields: {

            },
            
        }

    },
    created(){
        this.initial()
    },
    methods:{  
        initial(){
            this.getData()
        },
        async getData() {
            let self = this
            let ulrlist = `${this.url}/list`
            this.dataList = await axios.post(ulrlist, {}).then((response)=> {
                this.isBusy = false    
                return response.data
            })
            this.total_rows =  this.dataList.length
        },

        onFiltered(filteredItems) {
          this.total_rows = filteredItems.length;
          this.current_page = 1;
      },
      getRole(data){
        let val = [];
        $.each(data, function(key, value){
            val[key] = `${value.name}`
        })
        return val.join(',')
    },
    add(){
       this.toParent('add',this.dataList)
   },
   edit(data){
       this.toParent('edit',data)
   },
   deleteData(idx,data){
    this.$swal({
        title: "Delete this order status?",
        text: "Are you sure? You won't be able to revert this!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        confirmButtonText: "Yes, Delete it!"
    }).then((result) => { 
        if (result.value) { 
            this.dataList.splice(idx, 1)
            this.axiosDelete(data.id)
        }
    });
},
axiosDelete(id){
    let self = this
    let ulrlist = `${this.url}/delete/${id}`
    axios.post(ulrlist).then(function(response) {
        self.data = response.data
    })
    .catch(function(error) {
        // console.error(error);
    });
},
toParent(action,data){
    let dataEmit = {
        action : action,
        data : data,
        back : this.name,
    }
    this.$emit('datacomponent', dataEmit)
},   
}
}
</script>
<style>
    </style
